package com.king011.fluter.mobile_audio_recorder

import android.media.AudioFormat
import android.media.AudioRecord
import android.media.MediaRecorder
import io.flutter.plugin.common.EventChannel.EventSink
import java.lang.Exception

interface Recorder {
    fun start()
    fun stop()
}

fun getBufferSize(sampleRate: Int, channel: Int, eventSink: EventSink?): Int? {
    var channelConfig = AudioFormat.CHANNEL_IN_MONO
    if (channel == 2) {
        channelConfig = AudioFormat.CHANNEL_IN_STEREO
    }
    try {
        return AudioRecord.getMinBufferSize(sampleRate,
                channelConfig,
                AudioFormat.ENCODING_PCM_16BIT)
    } catch (e: Exception) {
        eventSink!!.error("AudioRecord", "$e", null)
    }
    return null
}
fun createAudioRecord(sampleRate: Int, channel: Int, bufferSize: Int, eventSink: EventSink?): AudioRecord? {
    var channelConfig = AudioFormat.CHANNEL_IN_MONO
    if (channel == 2) {
        channelConfig = AudioFormat.CHANNEL_IN_STEREO
    }
    try {
        return AudioRecord(
                MediaRecorder.AudioSource.MIC,
                sampleRate,
                channelConfig,
                AudioFormat.ENCODING_PCM_16BIT,
                bufferSize)
    } catch (e: Exception) {
        eventSink!!.error("AudioRecord", "$e", null)
    }
    return null
}
